function [Texp,Lexp]=lexp(odefun,jacobian,tspan,y0)
stept=0.2;
ioutp=100;
n1=length(y0); n2=n1*(n1+1);
nit = round(diff(tspan)/stept); % Number of steps
% Memory allocation
y=zeros(n2,1); cum=zeros(n1,1);
Lexp=zeros(n1,nit); Texp=zeros(1,nit);
% Initial values
rhs_ext=@(t,x) [odefun(t,x);reshape(jacobian(t,x)*reshape(x(n1+1:n2),n1,n1),n2-n1,1)];
y=[y0(:);reshape(eye(n1),n1^2,1)];
t=tspan(1);
% Main loop
for ITERLYAP=1:nit
[T,Y] = ode45(rhs_ext,[t t+stept],y); % Solutuion of extended ODE system
t=t+stept; y=Y(size(Y,1),:); % Take the last computed point
[Q,R]=qr(reshape(y(n1+1:n2),n1,n1)); % Construct new orthonormal basis
y(n1+1:n2)=Q(:);
cum=cum+log(abs(diag(R))); % Compute lyapunov coefficient
lp=cum/(t-tspan(1)); % normalize exponent
Lexp(:,ITERLYAP)=lp; Texp(ITERLYAP)=t;
if (mod(ITERLYAP,ioutp)==0)
fprintf('t=%6.4f ',t); fprintf('%10.6f ',lp); fprintf('\n');
end
end
figure, plot(Texp,Lexp)
end